Index: soft/giet_vm/giet_fat32/fat32.c
===================================================================
--- soft/giet_vm/giet_fat32/fat32.c	(revision 569)
+++ soft/giet_vm/giet_fat32/fat32.c	(revision 587)
@@ -762,189 +1094,1649 @@
     }
 
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _update_fs_info() : nb_free = %x / first_free = %x\n",
+        _fat.free_clusters_number , _fat.first_free_cluster );
+#endif
+
     return 0;
 }  // end _update_fs_info()
 
-//////////////////////////////////////////////////////////////////////////////////
-// This function update FAT, write a new value into cluster index.
-// Used by the function _fat_allocate to update the chaining of clusters.
-// Return 0 in case of success, > 0 if failure.
-//////////////////////////////////////////////////////////////////////////////////
-static inline 
-unsigned int _update_fat( unsigned int use_irq,
-                          unsigned int cluster, 
-                          unsigned int value  )
-{
-    unsigned int lba = _fat.fat_lba + (cluster / 128);
+
+
+/////////////////////////////////////////////////////////////////
+static inline unsigned int _get_fat_entry( unsigned int  cluster,
+                                           unsigned int* value )
+{
+    // compute cluster_id & entry_id in FAT
+    // a FAT cluster is an array of 1024 unsigned int entries
+    unsigned int       cluster_id = cluster >> 10;       
+    unsigned int       entry_id   = cluster & 0x3FF;
+
+    // get pointer on the relevant cluster descriptor in FAT cache
+    fat_cache_desc_t*  pdesc;
+    unsigned int*      buffer;
+    if ( _get_buffer_from_cache( NULL,               // Fat-Cache
+                                 cluster_id,
+                                 &pdesc ) ) return 1;
+
+    // get value from FAT slot
+    buffer = (unsigned int*)pdesc->buffer;
+    *value = buffer[entry_id];
+
+    return 0;
+}  // end _get_fat_entry()
+
+
+
+////////////////////////////////////////////////////////////////
+static inline unsigned int _set_fat_entry( unsigned int cluster, 
+                                           unsigned int value  )
+{
+    // compute cluster_id & entry_id in FAT
+    // a FAT cluster is an array of 1024 unsigned int entries
+    unsigned int cluster_id = cluster >> 10;
+    unsigned int entry_id   = cluster & 0x3FF;
+
+    // get pointer on the relevant cluster descriptor in FAT cache
+    fat_cache_desc_t*  pdesc;
+    unsigned int*      buffer; 
+    if ( _get_buffer_from_cache( NULL,               // Fat-Cache
+                                 cluster_id,
+                                 &pdesc ) )  return 1;           
+
+    // set value into FAT slot
+    buffer           = (unsigned int*)pdesc->buffer;
+    buffer[entry_id] = value;
+    pdesc->dirty     = 1;
+
+    return 0;
+} // end _set_fat_entry()
+
+
+
+//////////////////////////////////////////////////////
+static void _allocate_one_buffer( fat_inode_t*  inode,
+                                  unsigned int  cluster_id,
+                                  unsigned int  cluster )
+{
+    // search the 64-tree cache from top to bottom 
+    fat_cache_node_t*  node   = inode->cache;
+    unsigned int       level  = inode->levels;
+
+    while ( level )
+    {
+        // compute child index
+        unsigned int index = (cluster_id >> (6*(level-1))) & 0x3F;
+
+        if ( level == 1 )        // last level => children are cluster descriptors
+        {
+            fat_cache_desc_t* pdesc = (fat_cache_desc_t*)node->children[index];
+            if ( pdesc != NULL )      // slot not empty!!!
+            {
+                _printf("\n[FAT ERROR] in allocate_one buffer() : slot not empty "
+                        "in File-Cache <%s> / cluster_id = %d\n", inode->name , cluster_id );
+                _exit();
+            }
+ 
+            // allocate a cluster descriptor and a 4K buffer
+            pdesc = _malloc( sizeof(fat_cache_desc_t) );
+            unsigned char* buffer = _malloc( 4096 );
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _allocate_one_buffer() : buffer allocated to <%s> for cluster_id %d\n",
+        inode->name, cluster_id );
+#endif
+
+            // update cache and pdesc
+            node->children[index] = pdesc;
+            pdesc->lba     = _cluster_to_lba( cluster );
+            pdesc->buffer  = buffer;
+            pdesc->dirty   = 1;
+
+            // prepare next iteration
+            level--;
+        }
+        else                      // not last level => children are 64-tree nodes
+        {
+            fat_cache_node_t* child = (fat_cache_node_t*)node->children[index];
+            if ( child == NULL )  // miss 
+            {
+                // allocate a cache node if miss
+                child = (fat_cache_node_t*)_malloc( sizeof(fat_cache_node_t) );
+                node->children[index] = child;    
+            }
+
+            // prepare next iteration
+            node  = child;
+            level--;
+        }
+    } // end while
+} // end _allocate_one_buffer
+
+
+
+
+///////////////////////////////////////////////////////////////////
+static unsigned int _allocate_one_cluster( unsigned int*  cluster )  
+{
+    unsigned int nb_free = _fat.free_clusters_number;
+    unsigned int free    = _fat.first_free_cluster;
+
+    // scan FAT to get next free cluster index
+    unsigned int current = free;
+    unsigned int found   = 0;
+    unsigned int max     = (_fat.data_sectors >> 3);
+    unsigned int value;
+    do
+    {
+        // increment current
+        current++;
+
+        // get FAT entry indexed by current
+        if ( _get_fat_entry( current , &value ) ) return 1;
+        // test if free
+        if ( value == FREE_CLUSTER ) found = 1;
+    }
+    while ( (current < max) && (found == 0) );
+        
+    // check found  
+    if ( found == 0 )
+    {
+        _printf("\n[FAT_ERROR] in _allocate_one_cluster() : unconsistent FAT state");
+        return 1;
+    }
+
+    // update allocated FAT slot
+    if ( _set_fat_entry( free , END_OF_CHAIN_CLUSTER_MAX ) ) return 1;
+
+    // update FAT descriptor global variables
+    _fat.free_clusters_number = nb_free - 1;
+    _fat.first_free_cluster   = current;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _allocate_one_cluster() : cluster = %x / first_free = %x\n",
+        free , current );
+#endif
+
+    // returns free cluster index
+    *cluster = free;
+    return 0;
+
+}  // end _allocate_one_cluster()
+
+
+
+
+//////////////////////////////////////////////////////////////////////////
+static unsigned int _update_device_from_cache( unsigned int        levels,
+                                               fat_cache_node_t*   root,
+                                               char*               string )
+{
+    unsigned int index;
+    unsigned int ret = 0;
+
+    if ( levels == 1 )  // last level => children are cluster descriptors
+    {
+        for( index = 0 ; index < 64 ; index++ )
+        { 
+            fat_cache_desc_t* pdesc = root->children[index];
+            if ( pdesc != NULL )
+            { 
+                // update cluster on device if dirty
+                if ( pdesc->dirty )
+                {
+                    if ( _fat_ioc_access( 1,           // descheduling
+                                          0,           // to block device
+                                          pdesc->lba,
+                                          (unsigned int)pdesc->buffer,
+                                          8 ) )
+                    {
+                        _printf("\n[FAT_ERROR] in _update_device from_cache() : "
+                                " cannot access lba = %x\n", pdesc->lba );
+                        ret = 1;
+                    }
+                    else
+                    {
+                        pdesc->dirty = 0;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _update_device_from_cache() : cluster_id = %d for <%s>\n",
+        index , string );
+#endif
+
+                    }
+                }
+            }
+        }
+    }
+    else               // not the last level = recursive call on each children
+    {
+        for( index = 0 ; index < 64 ; index++ )
+        { 
+            fat_cache_node_t* pnode = root->children[index];
+            if ( pnode != NULL )
+            {
+                if ( _update_device_from_cache( levels - 1,
+                                                root->children[index],
+                                                string ) ) ret = 1;
+            }    
+        }
+    }
+    return ret;
+}  // end _update_device_from_cache()
+
+
+
+///////////////////////////////////////////////////////////////////
+static unsigned int _release_cache_memory( fat_cache_node_t*  root,
+                                           unsigned int       levels )
+{
+    unsigned int index;
+    unsigned int ret = 0;
+
+    if ( levels == 1 )  // last level => children are cluster descriptors
+    {
+        for( index = 0 ; index < 64 ; index++ )
+        { 
+            fat_cache_desc_t* pdesc = root->children[index];
+
+            if ( pdesc != NULL )
+            { 
+                // check dirty
+                if ( pdesc->dirty )
+                {
+                    _printf("\n[FAT_ERROR] in _release_cache_memory() : dirty cluster\n");
+                    ret = 1;
+                }
+                else
+                {
+                    _free( pdesc->buffer );
+                    _free( pdesc );
+                    root->children[index] = NULL;
+                }
+            }
+        }
+    }
+    else               // not the last level = recursive call on each children
+    {
+        for( index = 0 ; index < 64 ; index++ )
+        { 
+            fat_cache_node_t*    cnode = root->children[index];
+
+            if ( cnode != NULL ) ret   = _release_cache_memory( root->children[index],
+                                                                levels - 1 );
+        }
+    }
+    return ret;
+}  // end _release_cache_memory()
+
+
+
+
+
+/////////////////////////////////////////////////////////////
+static unsigned int _clusters_allocate( fat_inode_t* inode, 
+                                        unsigned int nb_current_clusters,
+                                        unsigned int nb_required_clusters )
+{
+    // Check if FAT contains enough free clusters
+    if ( nb_required_clusters > _fat.free_clusters_number )
+    {
+        _printf("\n[FAT ERROR] in _clusters_allocate() : required_clusters = %d"
+                " / free_clusters = %d\n", nb_required_clusters , _fat.free_clusters_number );
+        return 1;
+    }
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _clusters_allocate() : enters for <%s> / nb_current_clusters = %d "
+        "/ nb_required_clusters = %d\n", 
+        inode->name , nb_current_clusters , nb_required_clusters );
+#endif
+ 
+    // compute last allocated cluster index when (nb_current_clusters > 0)
+    unsigned int current = inode->cluster;
+    unsigned int next;
+    unsigned int last;
+    if ( nb_current_clusters )   // clusters allocated => search last
+    {    
+        while ( current < END_OF_CHAIN_CLUSTER_MIN )
+        {
+            // get next cluster
+            if ( _get_fat_entry( current , &next ) )  return 1;
+            last    = current;
+            current = next;
+        }
+    }  
+
+    // Loop on the new clusters to be allocated
+    // if (nb_current_clusters == 0) the first new cluster index must
+    //                               be written in inode->cluster field 
+    // if (nb_current_clusters >  0) the first new cluster index must
+    //                               be written in FAT[last]
+    unsigned int      cluster_id;
+    unsigned int      new;
+    for ( cluster_id = nb_current_clusters ; 
+          cluster_id < (nb_current_clusters + nb_required_clusters) ; 
+          cluster_id ++ )
+    {
+        // allocate one cluster on block device
+        if ( _allocate_one_cluster( &new ) ) return 1;
+
+        // allocate one 4K buffer to File-Cache
+        _allocate_one_buffer( inode,
+                              cluster_id,
+                              new );
+
+        if ( cluster_id == 0 )  // update inode 
+        {
+            inode->cluster = new;
+        }
+        else                    // update FAT
+        {
+            if ( _set_fat_entry( last , new ) ) return 1;
+        }
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _clusters_allocate() : done for cluster_id = %d / cluster = %x\n",
+        cluster_id , new );
+#endif
+
+        // update loop variables
+        last = new;
+
+    } // end for loop
+
+    // update FAT : last slot should contain END_OF_CHAIN_CLUSTER_MAX
+    if ( _set_fat_entry( last , END_OF_CHAIN_CLUSTER_MAX ) )  return 1;
+
+    // update the FAT on block device
+    if ( _update_device_from_cache( _fat.fat_cache_levels,
+                                    _fat.fat_cache_root,
+                                    "FAT" ) )              return 1;
+    return 0;
+}  // end _clusters_allocate()
+
+
+
+//////////////////////////////////////////////////////////////
+static unsigned int _clusters_release( unsigned int cluster )
+{
+    // scan the FAT
+    unsigned int current = cluster;
+    unsigned int next;
+    do
+    { 
+        // get next_cluster index
+        if ( _get_fat_entry( current , &next ) )  return 1;
+
+        // release current_cluster
+        if ( _set_fat_entry( current , FREE_CLUSTER ) )   return 1;
+
+        // update first_free_cluster and free_clusters_number in FAT descriptor
+        _fat.free_clusters_number = _fat.free_clusters_number + 1;
+        if ( _fat.first_free_cluster > current ) _fat.first_free_cluster = current;
+
+        // update loop variable
+        current = next;
+    }
+    while ( next < END_OF_CHAIN_CLUSTER_MIN );
+
+    // update the FAT on block device
+    if ( _update_device_from_cache( _fat.fat_cache_levels,
+                                    _fat.fat_cache_root,
+                                    "FAT" ) )                return 1;
+    return 0;
+}  // end _clusters_release()
+
+
+
+///////////////////////////////////////////////////////////
+static void _add_special_directories( fat_inode_t*  child, 
+                                      fat_inode_t*  parent )
+{
+    // get first File-Cache buffer for child
+    fat_cache_desc_t*   pdesc  = (fat_cache_desc_t*)child->cache->children[0];
+    unsigned char*      entry;
+
+    unsigned int i;
+    unsigned int cluster;
+    unsigned int size;
+
+    // set "." entry (32 bytes)
+    cluster = child->cluster;
+    size    = child->size;
+    entry   = pdesc->buffer;
+    
+    for ( i = 0 ; i < 32 ; i++ )
+    {
+        if      (i == 0 )     entry[i] = 0x2E;          // SFN
+        else if (i <  11)     entry[i] = 0x20;          // SFN
+        else if (i == 11)     entry[i] = 0x10;          // ATTR == dir
+        else if (i == 20)     entry[i] = cluster>>16;   // cluster.B2
+        else if (i == 21)     entry[i] = cluster>>24;   // cluster.B3
+        else if (i == 26)     entry[i] = cluster>>0;    // cluster.B0
+        else if (i == 27)     entry[i] = cluster>>8;    // cluster.B1
+        else if (i == 28)     entry[i] = size>>0;       // size.B0
+        else if (i == 29)     entry[i] = size>>8;       // size.B1
+        else if (i == 30)     entry[i] = size>>16;      // size.B2
+        else if (i == 31)     entry[i] = size>>24;      // size.B3
+        else                  entry[i] = 0x00;
+    }
+
+    // set ".." entry (32 bytes)
+    cluster = parent->cluster;
+    size    = parent->size;
+    entry   = pdesc->buffer + 32;
+
+    for ( i = 0 ; i < 32 ; i++ )
+    {
+        if      (i <  2 )     entry[i] = 0x2E;          // SFN
+        else if (i <  11)     entry[i] = 0x20;          // SFN
+        else if (i == 11)     entry[i] = 0x10;          // ATTR == dir
+        else if (i == 20)     entry[i] = cluster>>16;   // cluster.B2
+        else if (i == 21)     entry[i] = cluster>>24;   // cluster.B3
+        else if (i == 26)     entry[i] = cluster>>0;    // cluster.B0
+        else if (i == 27)     entry[i] = cluster>>8;    // cluster.B1
+        else if (i == 28)     entry[i] = size>>0;       // size.B0
+        else if (i == 29)     entry[i] = size>>8;       // size.B1
+        else if (i == 30)     entry[i] = size>>16;      // size.B2
+        else if (i == 31)     entry[i] = size>>24;      // size.B3
+        else                  entry[i] = 0x00;
+    }
+}  // end _add_special_directories
+
+
+
+////////////////////////////////////////////////////////////
+static unsigned int _check_name_length( char* name,
+                                        unsigned int* length,
+                                        unsigned int* nb_lfn )
+{
+    unsigned int len = _strlen( name );
+    if      ( len <= 13 )
+    {
+        *length  = len;
+        *nb_lfn  = 1;
+        return 0;
+    }
+    else if ( len <= 26 )
+    {
+        *length  = len;
+        *nb_lfn  = 2;
+        return 0;
+    }
+    else if ( len <= 31 )
+    {
+        *length  = len;
+        *nb_lfn  = 3;
+        return 0;
+    }
+    else
+    {
+        return 1;
+    }
+}  // _check_name_length()
+
+
+
+
+///////////////////////////////////////////////////////////
+static unsigned int _get_nb_entries( fat_inode_t*   inode,
+                                     unsigned int*  nb_entries )
+{
+    // scan directory until "end of directory" with two embedded loops:
+    // - scan the clusters allocated to this directory
+    // - scan the entries to find NO_MORE_ENTRY
+    fat_cache_desc_t*  pdesc;                      // pointer on buffer descriptor
+    unsigned char*     buffer;                     // 4 Kbytes buffer (one cluster)
+    unsigned int       ord;                        // ORD field in directory entry
+    unsigned int       attr;                       // ATTR field in directory entry
+    unsigned int       cluster_id = 0;             // cluster index in directory
+    unsigned int       offset     = 0;             // position in scanned buffer
+    unsigned int       found      = 0;             // NO_MORE_ENTRY found
+    unsigned int       count      = 0;             // number of valid NORMAL entries
+
+    // loop on clusters allocated to directory
+    while ( found == 0 )
+    {
+        // get one 4 Kytes buffer from File_Cache  
+        if ( _get_buffer_from_cache( inode,
+                                     cluster_id,
+                                     &pdesc ) )   return 1;
+
+        buffer = pdesc->buffer;
+        
+        // loop on directory entries in buffer
+        while ( (offset < 4096) && (found == 0) )
+        {
+            attr = _read_entry( DIR_ATTR , buffer + offset , 0 );   
+            ord  = _read_entry( LDIR_ORD , buffer + offset , 0 );
+
+            if ( ord == NO_MORE_ENTRY )
+            {
+                found = 1;
+            }  
+            else if ( ord == FREE_ENTRY )             // free entry => skip
+            {
+                offset = offset + 32;
+            }
+            else if ( attr == ATTR_LONG_NAME_MASK )   // LFN entry => skip
+            {
+                offset = offset + 32;
+            }
+            else                                      // NORMAL entry
+            {
+                count++;
+            }
+
+            offset = offset + 32;
+
+        }  // end loop on directory entries
+
+        cluster_id++;
+        offset = 0;
+
+    }  // end loop on clusters
+
+    // return nb_entries
+    *nb_entries = count;
+    
+    return 0;
+}  // end dir_not_empty()
+
+
+
+///////////////////////////////////////////////////////////
+static unsigned int _add_dir_entry( fat_inode_t*   child,
+                                    fat_inode_t*   parent )
+{
+    // get child attributes
+    unsigned int      is_dir  = child->is_dir;     
+    unsigned int      size    = child->size;
+    unsigned int      cluster = child->cluster;
+
+    // compute number of required entries to store child->name
+    // - Short name (less than 13 characters) require 3 entries: 
+    //   one LFN entry / one NORMAL entry / one NO_MORE_ENTRY entry.
+    // - Longer names (up to 31 characters) can require 4 or 5 entries:
+    //   2 or 3 LFN entries / one NORMAL entry / one NO_MORE entry.
+    unsigned int length;
+    unsigned int nb_lfn;
+    if ( _check_name_length( child->name, 
+                             &length,
+                             &nb_lfn ) )  return 1;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _add_dir_entry() : try to add <%s> in <%s> / nb_lfn = %d\n", 
+        child->name , parent->name, nb_lfn );
+#endif
+
+    // Find end of directory : two embedded loops:
+    // - scan the clusters allocated to this directory
+    // - scan the entries to find NO_MORE_ENTRY
+    fat_cache_desc_t*  pdesc;                      // pointer on buffer descriptor
+    unsigned char*     buffer;                     // 4 Kbytes buffer (one cluster)
+    unsigned int       cluster_id = 0;             // cluster index in directory
+    unsigned int       offset     = 0;             // position in scanned buffer
+    unsigned int       found      = 0;             // NO_MORE_ENTRY found
+
+    // loop on clusters allocated to directory
+    while ( found == 0 )
+    {
+        // get one 4 Kytes buffer from File_Cache  
+        if ( _get_buffer_from_cache( parent,
+                                     cluster_id,
+                                     &pdesc ) )   return 1;
+
+        buffer = pdesc->buffer;
+        
+        // loop on directory entries in buffer
+        while ( (offset < 4096) && (found == 0) )
+        {
+            if ( _read_entry( LDIR_ORD , buffer + offset , 0 ) == NO_MORE_ENTRY )
+            {
+                found        = 1;
+                pdesc->dirty = 1;
+            }  
+            else
+            {
+                offset = offset + 32;
+            }
+        }  // end loop on entries
+        if ( found == 0 )
+        {
+            cluster_id++;
+            offset = 0;
+        }
+    }  // end loop on clusters
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _add_dir_entry() : get NO_MORE directory entry : "
+        " buffer = %x / offset = %x / cluster_id = %d\n",
+        (unsigned int)buffer , offset , cluster_id );
+#endif
+
+    // enter FSM :
+    // The new child requires to write 3, 4, or 5 directory entries.
+    // To actually register the new child, we use a 5 steps FSM
+    // (one state per entry to be written), that is traversed as:
+    //    LFN3 -> LFN2 -> LFN1 -> NORMAL -> NOMORE 
+    // The buffer and first directory entry to be  written are identified 
+    // by the variables : buffer / cluster_id / offset 
+
+    unsigned char* name  = (unsigned char*)child->name;
+
+    unsigned int step;          // FSM state
+
+    if      ( nb_lfn == 1 ) step = 3;
+    else if ( nb_lfn == 2 ) step = 4;
+    else if ( nb_lfn == 3 ) step = 5;
+    
+    unsigned int   i;           // byte index in 32 bytes directory
+    unsigned int   c;           // character index in name
+    unsigned char* entry;       // buffer + offset;
+
+    while ( step )   
+    {
+        // get another buffer if required
+        if ( offset >= 4096 )  // new buffer required
+        {
+            if ( cluster_id == 63 )   // we need to increase depth of File-Cache
+            {
+                _printf("\n[FAT ERROR] in add_dir_entry() File Cache depth extension "
+                        " not implemented\n" );
+                _exit();  // TODO    
+            }
+            else
+            {
+                if ( _get_buffer_from_cache( parent,
+                                             cluster_id + 1,
+                                             &pdesc ) )      return 1;        
+                buffer       = pdesc->buffer;
+                pdesc->dirty = 1;
+                offset       = 0;
+            }
+        }
+
+        // compute directory entry address
+        entry = buffer + offset;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _add_dir_entry() : FSM step = %d /"
+        " offset = %x / nb_lfn = %d\n", step, offset, nb_lfn );
+#endif
+
+        // write one 32 bytes directory entry per iteration
+        switch ( step )
+        {
+            case 5:   // write LFN3 entry
+            {
+                c = 26;
+                // scan the 32 bytes in dir_entry
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if (i == 0)
+                    {
+                        if ( nb_lfn == 3) entry[i] = 0x43;
+                        else              entry[i] = 0x03;
+                    }
+                    else if ( ( ((i >= 1 ) && (i<=10) && ((i&1)==1))   ||
+                                ((i >= 14) && (i<=25) && ((i&1)==0))   ||
+                                ((i >= 28) && (i<=31) && ((i&1)==0)) ) &&
+                              ( c < length ) )
+                    {
+                                          entry[i] = name[c];
+                                          c++;
+                    }
+                    else if (i == 11)     entry[i] = 0x0F;
+                    else if (i == 12)     entry[i] = 0xCA;
+                    else                  entry[i] = 0x00;
+                }
+                step--;
+                break;
+            }
+            case 4:   // write LFN2 entry  
+            {
+                c = 13;
+                // scan the 32 bytes in dir_entry
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if (i == 0)
+                    {
+                        if ( nb_lfn == 2) entry[i] = 0x42;
+                        else              entry[i] = 0x02;
+                    }
+                    else if ( ( ((i >= 1 ) && (i<=10) && ((i&1)==1))   ||
+                                ((i >= 14) && (i<=25) && ((i&1)==0))   ||
+                                ((i >= 28) && (i<=31) && ((i&1)==0)) ) &&
+                              ( c < length ) )
+                    {
+                                          entry[i] = name[c];
+                                          c++;
+                    }
+                    else if (i == 11)     entry[i] = 0x0F;
+                    else if (i == 12)     entry[i] = 0xCA;
+                    else                  entry[i] = 0x00;
+                }
+                step--;
+                break;
+            }
+            case 3:   // Write LFN1 entry   
+            {
+                c = 0;
+                // scan the 32 bytes in dir_entry
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if (i == 0)
+                    {
+                        if ( nb_lfn == 1) entry[i] = 0x41;
+                        else              entry[i] = 0x01;
+                    }
+                    else if ( ( ((i >= 1 ) && (i<=10) && ((i&1)==1))   ||
+                                ((i >= 14) && (i<=25) && ((i&1)==0))   ||
+                                ((i >= 28) && (i<=31) && ((i&1)==0)) ) &&
+                              ( c < length ) )
+                    {
+                                          entry[i] = name[c];
+                                          c++;
+                    }
+                    else if (i == 11)     entry[i] = 0x0F;
+                    else if (i == 12)     entry[i] = 0xCA;
+                    else                  entry[i] = 0x00;
+                }
+                step--;
+                break;
+            }
+            case 2:   // write NORMAL entry     
+            {
+                c = 0;
+                // scan the 32 bytes in dir_entry
+                for ( i = 0 ; i < 32 ; i++ )
+                {
+                    if      ( (i < 8) && (c < length) )             // SFN
+                    {
+                                          entry[i] = _to_upper( name[c] );
+                                          c++;
+                    }
+                    else if (i <  11)     entry[i] = 0x20;          // EXT
+                    else if (i == 11)                               // ATTR
+                    {
+                        if (is_dir)       entry[i] = 0x10;
+                        else              entry[i] = 0x20;
+                    }
+                    else if (i == 20)     entry[i] = cluster>>16;   // cluster.B2
+                    else if (i == 21)     entry[i] = cluster>>24;   // cluster.B3
+                    else if (i == 26)     entry[i] = cluster>>0;    // cluster.B0
+                    else if (i == 27)     entry[i] = cluster>>8;    // cluster.B1
+                    else if (i == 28)     entry[i] = size>>0;       // size.B0
+                    else if (i == 29)     entry[i] = size>>8;       // size.B1
+                    else if (i == 30)     entry[i] = size>>16;      // size.B2
+                    else if (i == 31)     entry[i] = size>>24;      // size.B3
+                    else                  entry[i] = 0x00;
+                }
+
+                // update the dentry field in child inode
+                child->dentry = ((cluster_id<<12) + offset)>>5;
+
+                step--;
+                break;
+            }
+            case 1:   // write NOMORE entry  
+            {
+                step--;
+                entry [0] = 0x00;
+                break;
+            }
+        } // end switch step
+        offset += 32;
+    } // exit while => exit FSM    
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+{
+    _printf("\n[DEBUG FAT] _add_dir_entry() : <%s> successfully added in <%s>\n",
+            child->name , parent->name );
+}
+#endif
+
+    return 0;        
+} // end _add_dir_entry
+
+
+
+////////////////////////////////////////////////////////////
+static unsigned int _remove_dir_entry( fat_inode_t*  inode )
+{
+    // compute number of LFN entries
+    unsigned int length;
+    unsigned int nb_lfn;
+    if ( _check_name_length( inode->name, 
+                             &length,
+                             &nb_lfn ) )  return 1;
+
+    // get cluster_id and offset in parent directory cache
+    unsigned int  dentry     = inode->dentry;
+    unsigned int  cluster_id = dentry >> 7;
+    unsigned int  offset     = (dentry & 0x7F)<<5;
+
+    // get buffer from parent directory cache
+    unsigned char*     buffer;
+    fat_cache_desc_t*  pdesc;
+
+    if ( _get_buffer_from_cache( inode->parent,
+                                 cluster_id,
+                                 &pdesc ) ) return 1;
+    buffer       = pdesc->buffer;
+    pdesc->dirty = 1;
+
+    // invalidate NORMAL entry in directory cache
+    buffer[offset] = 0xE5;
+
+    // invalidate LFN entries
+    while ( nb_lfn )
+    {
+        if (offset == 0)  // me must load buffer for (cluster_id - 1) 
+        {
+            if ( _get_buffer_from_cache( inode->parent,
+                                         cluster_id - 1,
+                                         &pdesc ) )   return 1;
+            buffer       = pdesc->buffer;
+            pdesc->dirty = 1;
+            offset       = 4064;
+        }
+        else
+        {
+            offset = offset - 32;
+        }
+
+        // invalidate LFN entry
+        buffer[offset] = 0xE5;
+
+        nb_lfn--;
+    }     
+         
+    return 0;
+}  // end _remove_dir_entry
+
+
+
+
+////////////////////////////////////////////////////////////
+static unsigned int _update_dir_entry( fat_inode_t*  inode )
+{  
+    // get Cache-File buffer containing the parent directory entry
+    // 128 directories entries in one 4 Kbytes buffer
+    fat_cache_desc_t*  pdesc;
+    unsigned char*     buffer;   
+    unsigned int       cluster_id = inode->dentry>>7;
+    unsigned int       offset     = (inode->dentry & 0x3F)<<5;
+
+    if ( _get_buffer_from_cache( inode->parent,
+                                 cluster_id,
+                                 &pdesc ) )    return 1;
+    buffer       = pdesc->buffer;
+    pdesc->dirty = 1;
+
+    // update size field
+    buffer[offset + 28] = inode->size>>0;       // size.B0 
+    buffer[offset + 29] = inode->size>>8;       // size.B1 
+    buffer[offset + 30] = inode->size>>16;      // size.B2 
+    buffer[offset + 31] = inode->size>>24;      // size.B3 
+
+    // update cluster field
+    buffer[offset + 26] = inode->cluster>>0;    // cluster.B0 
+    buffer[offset + 27] = inode->cluster>>8;    // cluster.B1 
+    buffer[offset + 20] = inode->cluster>>16;   // cluster.B2 
+    buffer[offset + 21] = inode->cluster>>24;   // cluster.B3 
+    
+    return 0;
+} // end _update_dir_entry()
+
+
+
+
+//////////////////////////////////////////////////////////////////
+static unsigned int _get_child_from_parent( fat_inode_t*   parent,
+                                            char*          name, 
+                                            fat_inode_t**  inode )
+{
+    fat_inode_t*   current;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_child_from_parent() : search <%s> in directory <%s>\n",
+        name , parent->name );
+#endif
+
+    // compute name lenth
+    unsigned int length = _strlen( name );
+    
+    // scan inodes in the parent directory 
+    for ( current = parent->child ; current ; current = current->next )
+    {
+        if ( _strncmp( name , current->name , length ) == 0 ) 
+        {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_child_from_parent() : found inode <%s> in directory <%s>\n", 
+        name , parent->name );
+#endif
+            *inode = current;
+            return 0;           // name found
+        }
+    }
+
+    // not found in Inode-Tree => access the parent directory 
+    // file_cache.  Two embedded loops:
+    // - scan the clusters allocated to this directory
+    // - scan the directory entries in each 4 Kbytes buffer
+
+    unsigned char*    buffer;           // pointer on one cache buffer
+    char              cname[32];        // buffer for one full entry name 
+    char              lfn1[16];         // buffer for one partial name
+    char              lfn2[16];         // buffer for one partial name
+    char              lfn3[16];         // buffer for one partial name
+    unsigned int      size;             // searched file/dir size (bytes) 
+    unsigned int      cluster;          // searched file/dir cluster index
+    unsigned int      is_dir;           // searched file/dir type
+    unsigned int      attr;             // directory entry ATTR field
+    unsigned int      ord;              // directory entry ORD field
+    unsigned int      lfn;              // LFN entries number              
+    unsigned int      dentry;           // directory entry index 
+    unsigned int      offset     = 0;   // byte offset in buffer
+    unsigned int      cluster_id = 0;   // cluster index in directory
+    int               found      = 0;   // not found (0) / name found (1) / end of dir (-1)
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_child_from_parent() : does not found inode <%s>"
+        " in directory <%s> => search in cache\n", name , parent->name );
+#endif
+
+    // scan the clusters allocated to parent directory
+    while ( found == 0 )
+    {
+        // get one 4 Kytes buffer from parent File_Cache  
+        fat_cache_desc_t*  pdesc;
+        if ( _get_buffer_from_cache( parent,
+                                     cluster_id,
+                                     &pdesc ) )    return 2;
+        buffer = pdesc->buffer;
+
+        // scan this buffer until end of directory, end of buffer, or name found
+        while( (offset < 4096) && (found == 0) )
+        {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_child_from_parent() : scan buffer %d for <%s>\n",
+        cluster_id , name );
+#endif
+            attr = _read_entry( DIR_ATTR , buffer + offset , 0 );   
+            ord  = _read_entry( LDIR_ORD , buffer + offset , 0 );
+
+            if (ord == NO_MORE_ENTRY)                 // no more entry in directory => break
+            {
+                found = -1;
+            }
+            else if ( ord == FREE_ENTRY )             // free entry => skip
+            {
+                offset = offset + 32;
+            }
+            else if ( attr == ATTR_LONG_NAME_MASK )   // LFN entry => get partial name
+            {
+                unsigned int seq = ord & 0x3;
+                lfn = (seq > lfn) ? seq : lfn;   
+                if      ( seq == 1 ) _get_name_from_long( buffer + offset, lfn1 );
+                else if ( seq == 2 ) _get_name_from_long( buffer + offset, lfn2 );
+                else if ( seq == 3 ) _get_name_from_long( buffer + offset, lfn3 );
+                offset = offset + 32;
+            }
+            else                                 // NORMAL entry
+            {
+                // build the extracted name
+                if      ( lfn == 0 )
+                {
+                    _get_name_from_short( buffer + offset , cname );
+                }
+                else if ( lfn == 1 )
+                {
+                    _strcpy( cname      , lfn1 );
+                }   
+                else if ( lfn == 2 ) 
+                {
+                    _strcpy( cname      , lfn1 );
+                    _strcpy( cname + 13 , lfn2 );
+                }
+                else if ( lfn == 3 ) 
+                {
+                    _strcpy( cname      , lfn1 );
+                    _strcpy( cname + 13 , lfn2 );
+                    _strcpy( cname + 26 , lfn3 );
+                }
+                    
+                // test if extracted name == searched name
+                if ( _strncmp( name , cname , length ) == 0 )
+                {
+                    cluster = (_read_entry( DIR_FST_CLUS_HI , buffer + offset , 1 ) << 16) |
+                              (_read_entry( DIR_FST_CLUS_LO , buffer + offset , 1 )      ) ;
+                    dentry  = ((cluster_id<<12) + offset)>>5;
+                    is_dir  = ((attr & ATTR_DIRECTORY) == ATTR_DIRECTORY);
+                    size    = _read_entry( DIR_FILE_SIZE , buffer + offset , 1 );
+                    found   = 1;
+                }
+                offset = offset + 32;
+                lfn    = 0;
+            }
+        }  // end loop on directory entries
+        cluster_id++;
+        offset = 0;
+    }  // end loop on buffers
+
+    if ( found == -1 )  // found end of directory in parent directory 
+    {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_child_from_parent() : found end of directory in <%s>\n",
+        parent->name );
+#endif
+        *inode = NULL;
+        return 1;
+    }
+    else               // found searched name in parent directory
+    {
+        // allocate a new inode and an empty Cache-File
+        *inode = _allocate_one_inode( name,
+                                      is_dir,
+                                      cluster,
+                                      size,
+                                      0,             // count
+                                      dentry,
+                                      1 );           // cache_allocate
+
+        // introduce it in Inode-Tree
+        _add_inode_in_tree( *inode , parent );
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_child_from_parent() : found <%s> on device\n", name );
+#endif
+        return 0;
+    }
+}  // end _get_child_from_parent()
+
+
+
+
+//////////////////////////////////////////////////////////////////
+static unsigned int _get_inode_from_path( char*          pathname,
+                                          fat_inode_t**  inode )
+{
+    char                 name[32];         // buffer for one name in pathname
+    unsigned int         nb_read;	       // number of characters written in name[] 
+    fat_inode_t*         parent;           // parent inode
+    fat_inode_t*         child;            // child inode
+    unsigned int         last;             // while exit condition 
+    unsigned int         code;             // return value
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_inode_from_path() : enters for path <%s>\n", pathname );
+#endif
+
+    // handle root directory case
+    if ( _strncmp( pathname , "/" , 2 ) == 0 )
+    {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_inode_from_path() : found root inode for <%s>\n", 
+        pathname );
+#endif
+        *inode  = _fat.inode_tree_root;
+        return 0;
+    }
+
+    // If the pathname is not "/", we traverse the inode tree from the root.
+    // We use _get_name_from_path() to scan pathname and extract inode names.
+    // We use _get_child_from_parent() to scan each directory in the path. 
+
+    last       = 0;
+    nb_read    = 0;                      // number of characters analysed in path
+    parent     = _fat.inode_tree_root;   // Inode-Tree root 
+    
+    while ( last == 0 )
+    {
+        // get searched file/dir name
+        if ( _get_name_from_path( pathname, name, &nb_read ) )
+        {
+            return 3;   // error : name too long
+        }
+
+        // compute last iteration condition
+        last = (pathname[nb_read] == 0);
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_inode_from_path() : got name <%s>\n", name );
+#endif
+
+        // get child inode from parent directory
+        code = _get_child_from_parent( parent,
+                                       name,
+                                       &child );
+
+        // we  need to find the child inode for all non terminal names
+        if ( (code == 2) || ((code == 1 ) && (last == 0)) )
+        {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_inode_from_path() : neither parent, nor child found for <%s>\n", 
+        pathname );
+#endif
+            return 2;  // error : parent inode not found
+        }
+        
+        // update parent if not the last iteration
+        if ( last == 0 ) parent = child;
+
+    } // end while
+
+    // returns inode pointer
+    if (code == 0 )
+    {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_inode_from_path() : found inode for <%s>\n", 
+        pathname );
+#endif
+        *inode  = child;
+    }
+    else
+    {
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _get_inode_from_path() : found only parent inode for <%s>\n",
+        pathname );
+#endif
+        *inode  = parent;
+    }
+
+    return code;                 // can be 0 (found) or 1 (not found)
+
+}  // end _get_inode_from_path() 
+
+
+
+
+//////////////////////////////////////////////////////////////
+static unsigned int _remove_node_from_fs( fat_inode_t* inode )
+{
+    // remove entry in parent directory
+    if ( _remove_dir_entry( inode ) ) return 1;
+
+    // update parent directory on device
+    if ( _update_device_from_cache( inode->parent->levels,
+                                    inode->parent->cache,
+                                    inode->parent->name ) ) return 1;
+
+    // release clusters allocated to file/dir in DATA region
+    if ( _clusters_release( inode->cluster ) ) return 1;
+
+    // release File-Cache
+    if ( _release_cache_memory( inode->cache,
+                                inode->levels ) ) return 1;
+
+    // remove inode from Inode-Tree
+    _remove_inode_from_tree( inode );
+
+    // release inode
+    _free ( inode );
+
+    return 0;
+}  // end _remove_node_from_fs()
+
+
+//////////////////////////////////////////////////////////////////
+static unsigned int _next_cluster_no_cache( unsigned int   cluster,
+                                            unsigned int*  next )
+{
+    // compute cluster_id and slot_id 
+    // each cluster contains 1024 slots (4 bytes per slot)
+    unsigned int cluster_id  = cluster >> 10;
+    unsigned int slot_id     = cluster & 0x3FF;
+
+    // compute lba of cluster identified by cluster_id
+    unsigned int lba = _fat.fat_lba + (cluster_id << 3);
+
+    // get cluster containing the adressed FAT slot in FAT buffer
+    if ( _fat_buffer_fat_lba != lba )
+    {
+        if ( _fat_ioc_access( 0,         // no descheduling
+                              1,         // read
+                              lba,
+                              (unsigned int)_fat_buffer_fat,
+                              8 ) )
+        {
+            _printf("\n[FAT ERROR] in _next_cluster_no_cache() : "
+                    "cannot load lba = %x into fat_buffer\n", lba );
+            return 1;
+        }
+
+        _fat_buffer_fat_lba = lba;
+    }
+
+    // return next cluster index
+    unsigned int* buf = (unsigned int*)_fat_buffer_fat;
+    *next = buf[slot_id];
+    return 0;
+   
+}  // end _next_cluster_no_cache()
+
+
+
+
+/////////////////////////////////////////////////////////////////
+static unsigned int _file_info_no_cache( char*          pathname,
+                                         unsigned int*  file_cluster,
+                                         unsigned int*  file_size )
+{
+    
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _file_info_no_cache() : enters for path <%s>\n", pathname );
+#endif
+
+    char            name[32];             // buffer for one name in the analysed pathname
+    char            lfn1[16];             // buffer for a partial name in LFN entry
+    char            lfn2[16];             // buffer for a partial name in LFN entry
+    char            lfn3[16];             // buffer for a partial name in LFN entry
+    char            cname[32];            // buffer for a full name in a directory entry
+    unsigned int    nb_read;           	  // number of characters analysed in path 
+    unsigned int    length;               // searched name length
+    unsigned int    parent_cluster;       // cluster index for the parent directory 
+    unsigned int    child_cluster;        // cluster index for the searched file/dir
+    unsigned int    child_size;           // size of the searched file/dir
+    unsigned int    child_is_dir;         // type of the searched file/dir
+    unsigned int    offset;               // offset in a 4 Kbytes buffer
+    unsigned int    ord;                  // ORD field in a directory entry
+    unsigned int    attr;                 // ATTR field in a directory entry
+    unsigned int    lfn;                  // number of lfn entries
+    unsigned char*  buf;                  // pointer on a 4 Kbytes buffer 
+    unsigned int    found;                // name found in current directory entry
+
+    // Three embedded loops: 
+    // - scan pathname to extract file/dir names, 
+    // - for each name, scan the clusters of the parent directory
+    // - for each cluster, scan the 4 Kbytes buffer to find the file/dir name
+    // The starting point is the root directory (cluster 2)
+
+    nb_read        = 0;
+    parent_cluster = 2; 
+
+    // scan pathname  
+    while ( pathname[nb_read] != 0 )    
+    {
+        // get searched file/dir name
+        if ( _get_name_from_path( pathname, name, &nb_read ) ) return 1;
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _file_info_no_cache() : search name <%s>"
+        " in cluster %x\n", name , parent_cluster );
+#endif
+        found  = 0;
+        length = _strlen( name );
+
+        // scan clusters containing the parent directory
+        while ( found == 0 )  
+        {
+            // compute lba 
+            unsigned int lba = _cluster_to_lba( parent_cluster );
+
+            // load one cluster of the parent directory into data_buffer
+            if ( _fat_buffer_data_lba != lba )
+            {
+                if ( _fat_ioc_access( 0,         // no descheduling
+                                      1,         // read
+                                      lba,
+                                      (unsigned int)_fat_buffer_data,
+                                      8 ) )
+                {
+                    _printf("\n[FAT ERROR] in _file_info_no_cache() : "
+                            "cannot load lba = %x into data_buffer\n", lba );
+                    return 1;
+                }
+
+                _fat_buffer_data_lba = lba;
+            }
+
+            offset = 0;
+
+            // scan this 4 Kbytes buffer 
+            while ( (offset < 4096) && (found == 0) )
+            {
+                buf  = _fat_buffer_data + offset;
+                attr = _read_entry( DIR_ATTR , buf , 0 );   
+                ord  = _read_entry( LDIR_ORD , buf , 0 );
+
+                if (ord == NO_MORE_ENTRY)               // no more entry => break
+                {
+                    found = 2;
+                }
+                else if ( ord == FREE_ENTRY )           // free entry => skip
+                {
+                    offset = offset + 32;
+                }
+                else if ( attr == ATTR_LONG_NAME_MASK ) // LFN entry => get partial name
+                {
+                    unsigned int seq = ord & 0x3;
+                    lfn = (seq > lfn) ? seq : lfn;   
+                    if      ( seq == 1 ) _get_name_from_long( buf, lfn1 );
+                    else if ( seq == 2 ) _get_name_from_long( buf, lfn2 );
+                    else if ( seq == 3 ) _get_name_from_long( buf, lfn3 );
+                    offset = offset + 32;
+                }
+                else                                    // NORMAL entry
+                {
+                    // build the full mame for current directory entry
+                    if      ( lfn == 0 )
+                    {
+                        _get_name_from_short( buf , cname );
+                    }
+                    else if ( lfn == 1 )
+                    {
+                        _strcpy( cname      , lfn1 );
+                    }   
+                    else if ( lfn == 2 ) 
+                    {
+                        _strcpy( cname      , lfn1 );
+                        _strcpy( cname + 13 , lfn2 );
+                    }
+                    else if ( lfn == 3 ) 
+                    {
+                        _strcpy( cname      , lfn1 );
+                        _strcpy( cname + 13 , lfn2 );
+                        _strcpy( cname + 26 , lfn3 );
+                    }
+                    
+                    // test if extracted name == searched name
+                    if ( _strncmp( name , cname , length ) == 0 )
+                    {
+                        child_cluster = (_read_entry( DIR_FST_CLUS_HI , buf , 1 ) << 16) |
+                                        (_read_entry( DIR_FST_CLUS_LO , buf , 1 )      ) ;
+                        child_is_dir  = ((attr & ATTR_DIRECTORY) == ATTR_DIRECTORY);
+                        child_size    = _read_entry( DIR_FILE_SIZE , buf , 1 );
+                        found         = 1;
+                    }
+                    offset = offset + 32;
+                    lfn = 0;
+                }
+            }  // en loop on directory entries
+            
+            // compute next cluster index
+            unsigned int next;
+            if ( _next_cluster_no_cache ( parent_cluster , &next ) ) return 1;
+            parent_cluster = next;
+        } // end loop on clusters 
+
+        if ( found == 2 )  // found end of directory => error
+        { 
+            _printf("\n[FAT ERROR] in _file_info_no_cache() : <%s> not found\n",
+                    name );
+            return 1;
+        }
+ 
+        // check type
+        if ( ((pathname[nb_read] == 0) && (child_is_dir != 0)) ||
+             ((pathname[nb_read] != 0) && (child_is_dir == 0)) )
+        {
+            _printf("\n[FAT ERROR] in _file_info_no_cache() : illegal type for <%s>\n", name );
+            return 1;
+        }
+
+        // update parent_cluster for next name
+        parent_cluster = child_cluster;
+
+    }  // end loop on names
+
+#if (GIET_DEBUG_FAT & 1)
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_printf("\n[DEBUG FAT] _file_info_no_cache() : success for <%s> / "
+        "file_size = %x / file_cluster = %x\n", pathname, child_size, child_cluster );
+#endif
+
+    // return file cluster and size
+    *file_size    = child_size;
+    *file_cluster = child_cluster;
+    return 0;
+
+}  // end _file_info_no_cache()
+
+
+
+/////////////////////////////////////////////////////////////////////////////
+/////////////////////////////////////////////////////////////////////////////
+//             Extern functions                                               
+/////////////////////////////////////////////////////////////////////////////
+/////////////////////////////////////////////////////////////////////////////
+
+
+/////////////////////////////////////////////////////////////////////////////
+// This function initializes the FAT structures.
+// - The Fat-Descriptor is always initialised.
+// - The dynamically allocated structures (the Inode-Tre, the Fat_Cache, 
+//   and the File-Cache for the root directory) are only allocated
+//   and initialised if the "kernel_mode" argument is set.
+/////////////////////////////////////////////////////////////////////////////
+// Implementation note:
+// This function is called twice, by the boot-loader, and by the kernel_init.
+// It does not use dynamic memory allocation from the distributed heap.
+// It use informations found in the boot sector and FS-INFO sector.
+// that are loaded in the Fat-Descriptor temporary block_buffer.
+/////////////////////////////////////////////////////////////////////////////
+// Returns 0 if success.
+// Returns -1 if error.
+/////////////////////////////////////////////////////////////////////////////
+int _fat_init( unsigned int kernel_mode )  
+{
 
 #if GIET_DEBUG_FAT
 if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _update_fat() : cluster = %x / value = %x\n", 
-        cluster, value );
-#endif
-
-    // update FAT cache in case of miss
-    if ( lba != _fat.cache_lba )  
-    {
-        if ( _fat_ioc_access( use_irq,
-                              1,                 // read
-                              lba, 
-                              (unsigned int)_fat.fat_cache, 
-                              1 ) )              // one sector
-        {
-            _printf("\n[FAT_ERROR] in _update_fat() cannot read block %x\n",
-                    lba );
-            return 1;
-        }
-        _fat.cache_lba = lba;
-    }
-
-    _write_entry( ((cluster % 128) << 2), 4, _fat.fat_cache, value );
-
-    // write bloc to FAT
-    if ( _fat_ioc_access( use_irq,
-                          0,                // write
-                          lba,
-                          (unsigned int)_fat.fat_cache,
-                          1 ) )             // one sector
-    {
-        _printf("\n[FAT_ERROR] in _update_fat() cannot write block %x\n",
-                lba );
-        return 1;
-    }
+_printf("\n[DEBUG FAT] _fat_init() : enters at cycle %d\n", _get_proctime() );
+#endif
+
+    // FAT initialisation should be done only once
+    if ( _fat.initialised == FAT_INITIALISED )
+    {
+        _printf("\n[FAT ERROR] in _fat_init() : FAT already initialised\n");
+        return -1;
+    }
+
+    // load Boot sector (VBR) into FAT buffer
+    if ( _fat_ioc_access( 0,                                  // no descheduling
+                          1,                                  // read
+                          0,                                  // block index
+                          (unsigned int)_fat.block_buffer,
+                          1 ) )                               // one block 
+    {
+        _printf("\n[FAT ERROR] in _fat_init() cannot load VBR\n");
+        return -1;
+    }
+
+    _fat.block_buffer_lba = 0;
+    
+#if GIET_DEBUG_FAT 
+if ( _get_proctime() > GIET_DEBUG_FAT )
+{
+    _printf("\n[DEBUG FAT] _fat_init() : Boot sector loaded\n");
+    _display_one_block( _fat.block_buffer, "block device", _fat.block_buffer_lba );
+}
+#endif
+
+    // checking various FAT32 assuptions from boot sector
+    if( _read_entry( BPB_BYTSPERSEC, _fat.block_buffer, 1 ) != 512 )
+    {
+        _printf("\n[FAT ERROR] The sector size must be 512 bytes\n");
+        return -1;
+    }
+    if( _read_entry( BPB_SECPERCLUS, _fat.block_buffer, 1 ) != 8 )
+    {
+        _printf("\n[FAT ERROR] The cluster size must be 8 blocks\n");
+        return -1;
+    }
+    if( _read_entry( BPB_NUMFATS, _fat.block_buffer, 1 ) != 1 )
+    {
+        _printf("\n[FAT ERROR] The number of FAT copies in FAT region must be 1\n");
+        return -1;
+    }
+    if( (_read_entry( BPB_FAT32_FATSZ32, _fat.block_buffer, 1 ) & 0xF) != 0 )
+    {
+        _printf("\n[FAT ERROR] The FAT region must be multiple of 16 sectors\n");
+        return -1;
+    }
+    if( _read_entry( BPB_FAT32_ROOTCLUS, _fat.block_buffer, 1 ) != 2 )
+    {
+        _printf("\n[FAT ERROR] The root directory must be at cluster 2\n");
+        return -1;
+    }
+
+    // initialise Fat-Descriptor from VBR
+    _fat.sector_size         = 512;
+    _fat.cluster_size        = 4096;
+    _fat.fat_sectors         = _read_entry( BPB_FAT32_FATSZ32 , _fat.block_buffer , 1 );
+    _fat.fat_lba             = _read_entry( BPB_RSVDSECCNT , _fat.block_buffer , 1 );
+    _fat.data_sectors        = _fat.fat_sectors << 10;
+    _fat.data_lba            = _fat.fat_lba + _fat.fat_sectors;
+    _fat.fs_info_lba         = _read_entry( BPB_FAT32_FSINFO , _fat.block_buffer , 1 );
+    _fat_buffer_fat_lba      = 0xFFFFFFFF;
+    _fat_buffer_data_lba     = 0xFFFFFFFF;
+    _fat.initialised         = FAT_INITIALISED;
+
+    // load FS_INFO sector into FAT buffer
+    if ( _fat_ioc_access( 0,                                // no descheduling 
+                          1,                                // read
+                          _fat.fs_info_lba,                 // lba 
+                          (unsigned int)_fat.block_buffer,
+                          1 ) )                             // one block
+    { 
+        _printf("\n[FAT ERROR] in _fat_init() cannot load FS_INFO Sector\n"); 
+        return -1;
+    }
+
+    _fat.block_buffer_lba = _fat.fs_info_lba;
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+{
+    _printf("\n[DEBUG FAT] _fat_init() : FS-INFO sector loaded\n");
+    _display_one_block( _fat.block_buffer, "block device", _fat.block_buffer_lba );
+}
+#endif
+
+    // initialise Fat-Descriptor from FS_INFO
+    _fat.free_clusters_number   = _read_entry( FS_FREE_CLUSTERS    , _fat.block_buffer, 1);
+    _fat.first_free_cluster     = _read_entry( FS_FREE_CLUSTER_HINT, _fat.block_buffer, 1);
+
+    // This is done only when the _fat_init() is called in kernel mode
+
+    if ( kernel_mode )
+    {
+        unsigned int   n;
+
+        // allocate and initialise the Inode-Tree root 
+        fat_inode_t*      inode  = _malloc( sizeof(fat_inode_t) );
+        fat_cache_node_t* cache  = _malloc( sizeof(fat_cache_node_t) );
+
+        inode->parent   = NULL;        // no parent
+        inode->next     = NULL;        // no brother
+        inode->child    = NULL;        // children come later
+        inode->cache    = cache;       // empty cache
+        inode->cluster  = 2;           // forced value
+        inode->size     = 0;           // no size for a directory
+        inode->count    = 0;           // children come later
+        inode->dentry   = 0;           // no parent => no dentry
+        inode->levels   = 1;           // one level cache
+        inode->is_dir   = 1;           // it's a directory
+        _strcpy( inode->name , "/" );  
+
+        for ( n = 0 ; n < 64 ; n ++ )  cache->children[n] = NULL;
+
+        _fat.inode_tree_root = inode;
+
+        // initialise the lock
+        _spin_lock_init( &_fat.fat_lock );
+
+        // initialise File Descriptor Array
+        for( n = 0 ; n < GIET_OPEN_FILES_MAX ; n++ ) _fat.fd[n].allocated = 0;
+
+        // initialise fat_cache root
+        fat_cache_node_t*  fat_cache_root = _malloc( sizeof(fat_cache_node_t) );
+        _fat.fat_cache_root   = fat_cache_root;
+        _fat.fat_cache_levels = _get_levels_from_size( _fat.fat_sectors << 9 );
+        for ( n = 0 ; n < 64 ; n++ ) _fat.fat_cache_root->children[n] = NULL;
+
+    }  // end if kernel_mode
+
+#if GIET_DEBUG_FAT
+if ( _get_proctime() > GIET_DEBUG_FAT )
+_display_fat_descriptor();
+#endif
 
     return 0;
-} // end update_fat()
-
-//////////////////////////////////////////////////////////////////////////////////
-// This function allocate count clusters to a file by calling the
-// _update_fat function that takes care to update the chaining of clusters.
-// return 0 if success, -1 if failure
-//////////////////////////////////////////////////////////////////////////////////
-static inline 
-int _fat_allocate( unsigned int use_irq,
-                   unsigned int fd_id, 
-                   unsigned int count )
-{
-    unsigned int next_cluster = _fat.fd[fd_id].first_cluster;    // first cluster
-    unsigned int cluster_to_allocate = count;                   // to allocate
-    unsigned int last_cluster_file;                             // Last cluster 
-    unsigned int free_cluster = _fat.last_cluster_allocated + 1; // First free 
-
-    // Check if free_cluster is really free (must be true)
-    if ( _get_next_cluster( use_irq , free_cluster ) != FREE_CLUSTER)
-    {
-        _printf("\n[FAT ERROR] in _fat_allocate() : first free cluster not free\n");
-        return -1;
-    }
-    // Check if FAT contains enough cluster free for this allocation
-    if ( count > _fat.number_free_cluster )
-    {
-        _printf("\n[FAT ERROR] in _fat_allocate() : Not enough free cluster(s)\n");
-        return -1;
-    }
-
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] _fat_allocate() for fd = %d\n", fd_id );
-#endif
-
-    // Get the last cluster allocated for the file (seek END_OF_CHAIN_CLUSTER).
-    do 
-    {
-        last_cluster_file = next_cluster;
-        next_cluster      = _get_next_cluster( use_irq , next_cluster );
-    }
-    while ( next_cluster < END_OF_CHAIN_CLUSTER );
-
-    // Loop on the number of clusters to be allocated
-    while ( cluster_to_allocate > 0 )
-    {
-
-#if GIET_DEBUG_FAT
-if ( _get_proctime() > GIET_DEBUG_FAT )
-_printf("\n[DEBUG FAT] cluster to update = %x / free cluster = %x / count = %d\n",
-        last_cluster_file , free_cluster , cluster_to_allocate );
-#endif
-
-        // update, in the FAT, the value of last cluster allocated by the index
-        // of free cluster.
-        if ( _update_fat( use_irq , last_cluster_file , free_cluster ) )
-        {
-            _printf("\n[FAT ERROR] in _fat_allocate() : update fat failed\n");
-            return -1;
-        }
-
-        cluster_to_allocate = cluster_to_allocate - 1;
-        // Last cluster allocated is then free_cluster
-        last_cluster_file = free_cluster;
-
-        // Last cluster to allocate done, then we must close the chain of clusters
-        if ( cluster_to_allocate == 0 )
-        {
-            // update, in the FAT, the value of the last cluster allocated by
-            // END_OF_CHAIN_CLUSTER
-            if ( _update_fat( use_irq , last_cluster_file , END_OF_CHAIN_CLUSTER ) )
-            {
-                _printf("\n[FAT ERROR] in _fat_allocate() : update fat failed\n");
-                return -1;
-            }
-        }
-
-        free_cluster = free_cluster + 1;
-
-        // Check if free_cluster is really free (must be true)
-        if ( _get_next_cluster( use_irq , free_cluster ) != FREE_CLUSTER)
-        {
-            _printf("\n[FAT ERROR] in _fat_allocate() : free_cluster not free\n");
-            return -1;
-        }
-    }
-
-    // Update field number_free_cluster and last_cluster_allocated 
-    // of structure fat for next fat_allocate
-    _fat.last_cluster_allocated = last_cluster_file;
-    _fat.number_free_cluster    = _fat.number_free_cluster - count;
-
-    if ( _update_fs_info( use_irq ) )
-    {
-        _printf("\n[FAT ERROR] in _fat_allocate() : update fs_info failed\n");
-        return -1;
-    }
-
-    return 0;
-}  // end _fat_allocate()
-
-//////////////////////////////////////////////////////////////////////////////////
-// This function read the blocks defined by the cluster index argument, in a data 
-// region containing a directory to search the name of a file/firectory. 
-// It returns the cluster index of the file/directory when the name has been found,
-// as well as the file size, and the lba.
-// We consider 3 types of directory entries:
-// - SFN : directory entry associated to a Short File Name (8.3)
-// - LFN : directory entry associated to a Long File Name
-// - XTN : directory entry containing only a name extension for a Long File Name
-// The cluster index is always stored in a SFN or LFN entry.
-// Return cluster index if name found / Return -1 if not found.
-//////////////////////////////////////////////////////////////////////////////////
-static 
-int _scan_directory( unsigned int   use_irq,         // use descheduling mode 
-                     unsigned int   cluster,         // cluster of dir_entry 
-                     char*          file_name,       // searched file/dir name
-                     unsigned int*  file_size,       // file size
-                     unsigned int*  lba_dir_entry )  // lba of dir_entry
-{
-    char dir_entry[32];       // buffer to store a full directory_entry
-    char name_entry[14];      // buffer to store a 13 characters (partial) name
-
-    char sfn_string[12]    = {[0 ... 10] = ' ', '\0'};  // buffer Short File Name
-    unsigned int  is_sfn   = is_short(file_name, sfn_string); // file_name is short
-    unsigned int  offset   = 0;                         // byte offset in block
-    unsigned int  block_id = _fat.sectors_per_cluster;  // sector index 
-    unsigned int  lba      = cluster_to_lba(cluster);   // lba of cluster 
-    unsigned int  attr     = 0;                         // dir entry attribute
-    unsigned int  ord      = 0;                         // dir entry sequence
-    unsigned int  found    = 0;                         // searched name found
-    unsigned int  long_name_found = 0;                  // matching XTN found
-    unsigned int  searched_cluster;                     // searched cluster index
+}  // end _fat_init()
+
+
+
+
+///////////////////////////////////////////////////////////////////////////////
+// This function implements the giet_fat_open() system call.
+// The semantic is similar to the UNIX open() function, but only the O_CREATE
+// and O_RDONLY flags are supported. The UNIX access rights are not supported. 
+// If the file does not exist in the specified directory, it is created.
+// If the specified directory does not exist, an error is returned.
+// It allocates a file descriptor to the calling task, for the file identified 
+// by "pathname". If several tasks try to open the same file, each task  
+// obtains a private file descriptor. 
+// A node name (file or directory) cannot be larger than 31 characters.
+///////////////////////////////////////////////////////////////////////////////
+// Returns file descriptor index if success
+// Returns a negative value if error:
+//   -1  :  "fat not initialised"
+//   -2  :  "path to parent not found"
+//   -3  :  "one name in path too long"
+//   -4  :  "file not found"
+//   -5  :  "Cannot update parent directory"
+//   -6  :  "Cannot update DATA region"
+//   -7  :  "Cannot update FAT region"
+//   -8  :  "Cannot update FS_INFO sector"
+//   -9  :  "file descriptor array full"
+///////////////////////////////////////////////////////////////////////////////
+int _fat_open( char*        pathname,     // absolute path from root
+               unsigned int flags )       // O_CREATE and O_RDONLY
+{
+    unsigned int         fd_id;            // index in File-Descriptor-Array
+    unsigned int         code;             // error code
+    fat_inode_t*         inode;            // anonymous inode pointer
+    fat_inode_t*         child;            // pointer on searched file inode
+    fat_inode_t*         parent;           // pointer on parent directory inode
+    
+    // get flags
+    unsigned int create    = ((flags & O_CREATE) != 0);
+    unsigned int read_only = ((flags & O_RDONLY) != 0); 
 
 #if GIET_DEBUG_FAT
